//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                                              e-PSI@DoublePlus.mq4 |
//|                Copyright  2013, Igor Stepovoi aka TarasBY & Parf and JQS aka Joo |
//|                                                                taras_bulba@tut.by |
//|                                                                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2008-13, TarasBY WM R418875277808; Z670270286972"
#property link      "taras_bulba@tut.by"
//IIIIIIIIIIIIIIIIIII==================CONSTANS=================IIIIIIIIIIIIIIIIIIIIII+
#define BULL  0
#define BEAR  1
#define STOP -1
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  *****                   *****                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
extern string  SETUP_Expert         = "==========    ==========";
extern int     Magic                   = 2013;
extern int     MaxTrades               = 100;
extern int     TakeProfit              = 320;   //  
extern int     Stoploss                = 500;   //  
//------------------------------------------------------------------------------
extern int     Pipstep                 = 160;   // 
extern double  PipStepExponent         = 1.1;
extern bool    QuantumStep             = TRUE;
extern int     StartStepExp            = 1;
extern string  SETUP_Trailing       = "================== TRAILING ===================";
extern bool    UseTrailingStop         = FALSE;
extern int     TrailStart              = 100;
extern int     TrailStop               = 100;
extern string  Setup_Lots           = "============   =============";
extern double  Lots                    = 0.03;  //  
extern double  LotExponent             = 2.5;   //  
extern int     VariantLot              = 0;     // 0-1
extern bool    UseEquityStop           = FALSE;
extern double  TotalEquityRisk         = 30.0;
extern bool    UseTimeOut              = FALSE;
extern double  MaxTradeOpenHours       = FALSE;
extern string  SETUP_OsMA           = "------------------ JQS iOsMA ------------------";
extern int     Fast_P                  = 4;
extern int     Slow_P                  = 135;
extern int     Signal_P                = 39;
int            FASTmetod_P             = 1;     // 0-MODE_SMA; 1-MODE_EMA; 2-MODE_SMMA; 3-MODE_LWMA
int            SLOWmetod_P             = 3;     // 0-MODE_SMA; 1-MODE_EMA; 2-MODE_SMMA; 3-MODE_LWMA
int            MACDmetod_P             = 3;     // 0-MODE_SMA; 1-MODE_EMA; 2-MODE_SMMA; 3-MODE_LWMA
int            SIGNALmetod_P           = 3;     // 0-MODE_SMA; 1-MODE_EMA; 2-MODE_SMMA; 3-MODE_LWMA
//IIIIIIIIIIIIIIIIIII======  ======IIIIIIIIIIIIIIIIIIIIII+
double         PriceTarget, StartEquity, Spread, PipStepE, gda_StartEquity[2],
               AveragePrice, gd_LastPrice,
               gd_Lots, gda_Profit[2], gda_AveragePrice[2], Stopper = 0.0, gda_Price[2],
               AccountEquityHighAmt, PrevEquity, gd_SL, gd_TP, gd_Point;
int            timeprev = 0, expiration, gia_MyOrders[2], gia_MG[2],
               NumOfTrades = 0, total, MagicNumber;
bool           TradeNow = FALSE, LongTrade = FALSE, ShortTrade = FALSE,
               NewOrdersPlaced = FALSE;
string         EAName = "DoublePlus";
//IIIIIIIIIIIIIIIIIII=========  =======IIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custom expert initialization function                            |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int init() 
{
//----
    if (Digits % 2 == 1)
    {
        TakeProfit *= 10;
        Stoploss *= 10;
        Pipstep *= 10;
        TrailStart *= 10;
        TrailStop *= 10;
    }
    gd_Point = Point;
    gd_SL = Stoploss * gd_Point;
    gd_TP = TakeProfit * gd_Point;
    Spread = MarketInfo (Symbol(), MODE_SPREAD) * gd_Point;
    gia_MG[0] = Magic;
    gia_MG[1] = Magic + 1;
    ArrayInitialize (gda_AveragePrice, 0.);
//---- 
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custor expert deinitialization function                          |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int deinit() 
{
//---- 
//---- 
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custom expert iteration function                                 |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int start() 
{
    if (timeprev == Time[0]) return (0);
    timeprev = Time[0];
//----
    int    li_Ticket = 0, li_cmd = 1, li_OP = 1;
    double ld_ProfitALL = CalculateProfit (gda_Profit, gia_MG), CurrentPairProfit;
//----
    total = fMyPositions (gia_MyOrders, gia_MG);
    for (int z = 0; z <= 1; z++)
    {
        if (z == 1) {li_cmd = -1; li_OP = 0;}
        MagicNumber = gia_MG[z];
        NumOfTrades = gia_MyOrders[z];
        int PipStepE = NormalizeDouble (Pipstep * MathPow (PipStepExp (NumOfTrades), TradeStepExp (NumOfTrades)), 0);
        if (UseTrailingStop) if (NumOfTrades > 0) TrailingAlls (TrailStart, TrailStop, gda_AveragePrice[z]);
        if (UseTimeOut)
        {
            if (TimeCurrent() >= expiration)
            {
                CloseThisSymbolAll();
                Print ("Closed All due to TimeOut");
                continue;
            }
        }
        CurrentPairProfit = gda_Profit[z];
        if (UseEquityStop)
        {
            if (CurrentPairProfit < 0.0) if (MathAbs (CurrentPairProfit) > TotalEquityRisk / 100.0 * AccountEquityHigh())
            //if (CurrentPairProfit<=-TotalEquityRisk || CurrentPairProfit>=TotalEquityProfit)
            {
                CloseThisSymbolAll();
                Print ("Closed All due to Stop Out | Loss = ", CurrentPairProfit);
                NewOrdersPlaced = FALSE;
                continue;
            }
        }
        gda_Price[0] = Bid;
        gda_Price[1] = Ask;
        if (NumOfTrades > 0)
        {
            if (total < MaxTrades)
            {
                gd_LastPrice = fFind_LastPrice (z);
                if (li_cmd * (gd_LastPrice - gda_Price[li_OP]) >= PipStepE * gd_Point) TradeNow = TRUE;
                else TradeNow = FALSE;
            }
            else TradeNow = FALSE;
        }
        else
        {
            TradeNow = TRUE;
            gda_StartEquity[z] = AccountEquity();
            gd_LastPrice = fFind_LastPrice (z);
        }
        if (TradeNow)
        {
            color lca_colors[] = {Blue,Red};
            if (NumOfTrades > 0)
            {
                int li_curTrade = NumOfTrades;
                if (VariantLot == 1) if (CurrentPairProfit > 0.) li_curTrade = total;
                gd_Lots = Symbol_NL (Lots * MathPow (LotExponent, li_curTrade));
                li_Ticket = fOpenOrder (z, gd_Lots, gda_Price[li_OP], Symbol_Spred(), gda_Price[z], 0, 0, EAName + "-" + NumOfTrades, MagicNumber, 0, lca_colors[z]);
                if (li_Ticket < 0) {Print ("Error: ", GetLastError()); return (0);}
                NumOfTrades++;
                TradeNow = FALSE;
                NewOrdersPlaced = TRUE;
            }
            if (NumOfTrades == 0)
            {
                double PrevCl = iClose (Symbol(), 0, 2),
                       CurrCl = iClose (Symbol(), 0, 1);
                int    li_Candle = -1;
                if (z == 0) {if (PrevCl <= CurrCl) li_Candle = BULL;}
                else {if (PrevCl > CurrCl) li_Candle = BEAR;}
                gd_Lots = Symbol_NL (Lots * MathPow (LotExponent, NumOfTrades));
                li_Ticket = 0;
                int li_Signal = GetRealSignal();
                if (li_Candle == z)
                {
                    //if (iRSI(NULL,PERIOD_H1,14,PRICE_CLOSE,1)>RsiMinimum && z==1)
                    //if (iRSI(NULL,PERIOD_H1,14,PRICE_CLOSE,1)<RsiMaximum && z==0)
                    if (li_Signal == z)
                    {
                        li_Ticket = fOpenOrder (z, gd_Lots, gda_Price[li_OP], Symbol_Spred(), gda_Price[z], 0, 0, EAName + "-" + NumOfTrades, MagicNumber, 0, lca_colors[z]);
                        if (li_Ticket < 0) {Print ("Error: ", GetLastError()); return (0);}
                        NumOfTrades++;
                        NewOrdersPlaced = TRUE;
                    }
                }
                if (li_Ticket > 0) expiration = TimeCurrent() + 60.0 * (60.0 * MaxTradeOpenHours);
                TradeNow = FALSE;
            }
        }
        //----     -  TP
        if (NewOrdersPlaced)
        {
            fGet_AveragePrice (gda_AveragePrice, NumOfTrades, z);
            AveragePrice = gda_AveragePrice[z];
            if (AveragePrice == 0.) return (0);
            int li_Type;
            for (int li_pos = OrdersTotal() - 1; li_pos >= 0; li_pos--)
            {
                if (!OrderSelect (li_pos, SELECT_BY_POS, MODE_TRADES)) continue;
                if (OrderSymbol() != Symbol()) continue;
                if (OrderMagicNumber() != MagicNumber) continue;
                li_Type = OrderType();
                if (li_Type > 1) continue;
                if (NumOfTrades == 1) AveragePrice = OrderOpenPrice();
                if (li_Type == OP_BUY)
                {
                    PriceTarget = AveragePrice + gd_TP;
                    Stopper = AveragePrice - gd_SL;
                }
                if (li_Type == OP_SELL)
                {
                    PriceTarget = AveragePrice - gd_TP;
                    Stopper = AveragePrice + gd_SL;
                }
                PriceTarget = NormalizeDouble (PriceTarget, Digits);
                if (NormalizeDouble (PriceTarget - OrderTakeProfit(), Digits) != 0.)
                {
                    Print ("Modify(): #", OrderTicket(), " | TP = ", OrderTakeProfit(), " | NewTP[", li_cmd * (PriceTarget - OrderOpenPrice()) / Point, "] = ", PriceTarget, " | Average[", NumOfTrades, "] = ", AveragePrice);
                    OrderModify (OrderTicket(), OrderOpenPrice(), OrderStopLoss(), PriceTarget, 0, Yellow);
                }
            }
            NewOrdersPlaced = FALSE;
        }
    }
//---- 
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|          ""                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fMyPositions (int& ar_MyOrders[], int ar_MG[])
{
    int li_cnt = 0, li_total = OrdersTotal(), li_Type, li_NUM = -1;
//----
    ArrayInitialize (ar_MyOrders, 0);
    if (li_total == 0) return (0);
    for (int trade = li_total - 1; trade >= 0; trade--)
    {
        if (!OrderSelect (trade, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != Symbol()) continue;
        li_NUM = fGet_INDInArrayINT (OrderMagicNumber(), ar_MG);
        if (li_NUM < 0) continue;
        li_Type = OrderType();
        if (li_Type > 1) continue;
        li_cnt++;
        ar_MyOrders[li_NUM]++;
    }
//----
    return (li_cnt);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                            |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fGet_AveragePrice (double& ar_AveragePrice[],
                        int fi_Orders,
                        int fi_Type)
{
    if (fi_Orders == 0) return;
    static int lia_preOrders[] = {0,0};
    if (lia_preOrders[fi_Type] == fi_Orders) return;
    lia_preOrders[fi_Type] = fi_Orders;
    double ld_AveragePrice = 0., ld_Count = 0.;
    for (int li_pos = OrdersTotal() - 1; li_pos >= 0; li_pos--)
    {
        if (!OrderSelect (li_pos, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != Symbol()) continue;
        if (OrderMagicNumber() != MagicNumber) continue;
        if (OrderType() != fi_Type) continue;
        ld_AveragePrice += OrderOpenPrice() * OrderLots();
        ld_Count += OrderLots();
    }
    if (ld_Count != 0.) ar_AveragePrice[fi_Type] = NormalizeDouble (ld_AveragePrice / ld_Count, Digits);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void CloseThisSymbolAll() 
{
//---- 
    for (int trade = OrdersTotal() - 1; trade >= 0; trade--)
    {
        if (!OrderSelect (trade, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != Symbol()) continue;
        if (OrderMagicNumber() != MagicNumber) continue;
        if (OrderType() == OP_BUY) OrderClose (OrderTicket(), OrderLots(), Bid, Symbol_Spred(), Blue);
        if (OrderType() == OP_SELL) OrderClose (OrderTicket(), OrderLots(), Ask, Symbol_Spred(), Red);
        Sleep (1000);
    }
//---- 
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                                      |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fOpenOrder (int fi_Type,
                double fd_Lots,
                double fd_Level,
                int fi_Slip,
                double fd_OpenPrice,
                int fi_SL,
                int fi_TP,
                string fs_Comment,
                int fi_Magic,
                datetime ldt_Expiration,
                color fc_Color) 
{
    int ticket = 0, err = 0, c = 0, NumberOfTries = 100;
    for (c = 0; c < NumberOfTries; c++)
    {
        switch (fi_Type)
        {
            case 0:
                RefreshRates();
                ticket = OrderSend (Symbol(), OP_BUY, fd_Lots, Ask, fi_Slip, fGet_STOP (fi_Type, Bid, fi_SL), fGet_TAKE (fi_Type, Ask, fi_TP), fs_Comment, fi_Magic, ldt_Expiration, fc_Color);
                break;
            case 1:
                RefreshRates();
                ticket = OrderSend (Symbol(), OP_SELL, fd_Lots, Bid, fi_Slip, fGet_STOP (fi_Type, Ask, fi_SL), fGet_TAKE (fi_Type, Bid, fi_TP), fs_Comment, fi_Magic, ldt_Expiration, fc_Color);
                break;
            case 2:
                ticket = OrderSend (Symbol(), OP_BUYLIMIT, fd_Lots, fd_Level, fi_Slip, fGet_STOP (fi_Type % 2, fd_OpenPrice, fi_SL), fGet_TAKE (fi_Type % 2, fd_Level, fi_TP), fs_Comment, fi_Magic, ldt_Expiration, fc_Color);
                break;
            case 3:
                ticket = OrderSend (Symbol(), OP_SELLLIMIT, fd_Lots, fd_Level, fi_Slip, fGet_STOP (fi_Type % 2, fd_OpenPrice, fi_SL), fGet_TAKE (fi_Type % 2, fd_Level, fi_TP), fs_Comment, fi_Magic, ldt_Expiration, fc_Color);
                break;
            case 4:
                ticket = OrderSend (Symbol(), OP_BUYSTOP, fd_Lots, fd_Level, fi_Slip, fGet_STOP (fi_Type % 2, fd_OpenPrice, fi_SL), fGet_TAKE (fi_Type % 2, fd_Level, fi_TP), fs_Comment, fi_Magic, ldt_Expiration, fc_Color);
                break;
            case 5:
                ticket = OrderSend (Symbol(), OP_SELLSTOP, fd_Lots, fd_Level, fi_Slip, fGet_STOP (fi_Type % 2, fd_OpenPrice, fi_SL), fGet_TAKE (fi_Type % 2, fd_Level, fi_TP), fs_Comment, fi_Magic, ldt_Expiration, fc_Color);
                break;
        }
        err = GetLastError();
        if (err == 0/* NO_ERROR */) break;
        if (!(err == 4/* SERVER_BUSY */ || err == 137/* BROKER_BUSY */ || err == 146/* TRADE_CONTEXT_BUSY */ || err == 136/* OFF_QUOTES */)) break;
        Sleep (1000);
        if (IsStopped()) break;
    }
    return (ticket);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fGet_STOP (int fi_Type, double price, int stop) 
{
    if (stop == 0.) return (0.);
    switch (fi_Type)
    {
        case 0: return (NormalizeDouble (price - stop * gd_Point, Digits));
        case 1: return (NormalizeDouble (price + stop * gd_Point, Digits));
    }
    return (0.);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                                 |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fGet_TAKE (int fi_Type, double price, int stop) 
{
    if (stop == 0.) return (0.);
    switch (fi_Type)
    {
        case 0: return (NormalizeDouble (price + stop * gd_Point, Digits));
        case 1: return (NormalizeDouble (price - stop * gd_Point, Digits));
    }
    return (0.);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double CalculateProfit (double& ar_Profit[],
                        int ar_MG[]) 
{
    double ld_Profit = 0., ld_ProfitALL = 0.;
    int    li_Total = OrdersTotal(), li_NUM = -1, li_Type;
//----
    ArrayInitialize (ar_Profit, 0.);
    if (li_Total == 0) return (0.);
    for (int li_pos = li_Total - 1; li_pos >= 0; li_pos--)
    {
        if (!OrderSelect (li_pos, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != Symbol()) continue;
        li_NUM = fGet_INDInArrayINT (OrderMagicNumber(), ar_MG);
        if (li_NUM < 0) continue;
        li_Type = OrderType();
        if (li_Type > 1) continue;
        ld_Profit = OrderProfit();// + OrderCommission() + OrderSwap();
        ar_Profit[li_NUM] += ld_Profit;
        ld_ProfitALL += ld_Profit;
    }
//----
    return (ld_Profit);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void TrailingAlls (int pType,
                   int stop,
                   double AvgPrice) 
{
    if (stop == 0) return;
    int    profit, li_Total = OrdersTotal();
    double ld_SL, ld_NewSL;
//----
    //if (li_Total == 0) return;
    for (int trade = li_Total - 1; trade >= 0; trade--)
    {
        if (!OrderSelect (trade, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != Symbol()) continue;
        if (OrderMagicNumber() != MagicNumber) continue;
        if (OrderType() == OP_BUY)
        {
            profit = NormalizeDouble ((Bid - AvgPrice) / gd_Point, 0);
            if (profit < pType) continue;
            ld_SL = OrderStopLoss();
            ld_NewSL = NormalizeDouble (Bid - stop * gd_Point, Digits);
            if (ld_SL == 0.0 || (ld_SL != 0.0 && NormalizeDouble (ld_NewSL - ld_SL, Digits) > 0.))
            {
                Print ("TrailingAlls(): #", OrderTicket(), "/BUY | SL = ", ld_SL, " | NewSL = ", ld_NewSL);
                OrderModify (OrderTicket(), OrderOpenPrice(), ld_NewSL, OrderTakeProfit(), 0, Aqua);
            }
        }
        if (OrderType() == OP_SELL)
        {
            profit = NormalizeDouble ((AvgPrice - Ask) / gd_Point, 0);
            if (profit < pType) continue;
            ld_SL = OrderStopLoss();
            ld_NewSL = NormalizeDouble (Ask + stop * gd_Point, Digits);
            if (ld_SL == 0.0 || (ld_SL != 0.0 && NormalizeDouble (ld_SL - ld_NewSL, Digits) > 0.))
            {
                Print ("TrailingAlls(): #", OrderTicket(), "/SELL | SL = ", ld_SL, " | NewSL = ", ld_NewSL);
                OrderModify (OrderTicket(), OrderOpenPrice(), ld_NewSL, OrderTakeProfit(), 0, Red);
            }
        }
        Sleep (500);
    }
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double AccountEquityHigh() 
{
//---- 
    if (NumOfTrades == 0) AccountEquityHighAmt = AccountEquity();
    if (AccountEquityHighAmt < PrevEquity) AccountEquityHighAmt = PrevEquity;
    else AccountEquityHighAmt = AccountEquity();
    PrevEquity = AccountEquity();
//---- 
    return (AccountEquityHighAmt);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fFind_LastPrice (int fi_Type) 
{
    int      li_Ticket = 0;
    datetime ldt_OpenTime = 0;
//----
    for (int li_pos = OrdersTotal() - 1; li_pos >= 0; li_pos--)
    {
        if (!OrderSelect (li_pos, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != Symbol()) continue;
        if (OrderMagicNumber() != MagicNumber) continue;
        if (OrderType() != fi_Type) continue;
        if (ldt_OpenTime > OrderOpenTime()) continue;
        ldt_OpenTime = OrderOpenTime();
        li_Ticket = OrderTicket();
    }
    if (li_Ticket > 0)
    {if (OrderSelect (li_Ticket, SELECT_BY_TICKET)) return (OrderOpenPrice());}
//----
    return (0.);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double PipStepExp (int Step)
{
    double QStepEx =  0;
//----
    if (QuantumStep && Step >= StartStepExp) QStepEx = PipStepExponent;
    else QStepEx = 1;
//----
    return (QStepEx);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int TradeStepExp (int Trades)
{
    double TradeStep = 0;
//----
    if (QuantumStep && Trades >= StartStepExp) TradeStep = Trades - StartStepExp + 1;
    else TradeStep = Trades;
//----
    return (TradeStep);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int GetRealSignal()
{
    double i0 = iCustom (NULL, 0, "JQS_iOsMA", Fast_P, Slow_P, Signal_P, FASTmetod_P, SLOWmetod_P, MACDmetod_P, SIGNALmetod_P, 0, 0);
    //i1 = iCustom (NULL, 0, "JQS_iOsMA", Fast_P, Slow_P, Signal_P, FASTmetod_P, SLOWmetod_P, MACDmetod_P, SIGNALmetod_P, 0, 1);
//----
    if (i0 < 0.0) return (BEAR);
    if (i0 > 0.0) return (BULL);
//----
    return (STOP);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int Symbol_Spred() {return (MarketInfo (Symbol(), MODE_SPREAD));}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double Symbol_NL (double lot)
{
    double minlot = MarketInfo (Symbol(), MODE_MINLOT);
//----
    if (lot <= minlot) return (minlot);
    else
    {
        double step = MarketInfo (Symbol(), MODE_LOTSTEP);
        if (step != 0) return (minlot + step * MathRound ((lot - minlot) / step));
    }
//----
    return (0.);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|  UNI:                                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fGet_INDInArrayINT (int fi_Value,       //  
                        int ar_Array[])     //  
{
//---- 
    for (int li_IND = 0; li_IND < ArraySize (ar_Array); li_IND++)
    {if (ar_Array[li_IND] == fi_Value) return (li_IND);}
//---- 
    return (-1);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

